<?php

namespace App\Controller;

use KnpU\OAuth2ClientBundle\Client\ClientRegistry;
use League\OAuth2\Client\Provider\Exception\IdentityProviderException;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;


class HomeController extends AbstractController
{
    #[Route('/', name: 'app_home')]
    public function index(): Response
    {
        return $this->render('home/index.html.twig', [
        ]);
    }

    #[Route('/osm/request', name: 'app_osm_request')]
    public function osmRequest(ClientRegistry $clientRegistry): Response
    {
        return $clientRegistry
            ->getClient('openstreetmap') 
            ->redirect([
                'read_prefs',
            ]);
    }

    #[Route('/osm/callback', name: 'app_osm_callback')]
    public function osmCallback(Request $request, ClientRegistry $clientRegistry): Response
    {
        $client = $clientRegistry->getClient('openstreetmap');

        try {
            $resourceOwner = $client->fetchUser();
            dump(
                $resourceOwner->getId(),
                $resourceOwner->getDisplayName()
            );
            $this->addFlash('success', 'Authentification OSM réussie !');
        } catch (IdentityProviderException $exception) {
            $this->addFlash('success', 'Échec de l’authentification OSM !');
        }

        return $this->redirectToRoute('app_home');
    }

}
