<?php

namespace App\Form;

use App\Entity\Task;
use App\Form\TaskLifecycleType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class TaskType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('name', null, ['label' => 'Nom'])
            ->add('description', null, ['label' => 'Description'])
            ->add('geojson', TextareaType::class, ['label' => 'GeoJSON'])
            ->add('osm', TextareaType::class, ['label' => 'OSM'])
            ->add('status', TaskLifecycleType::class, ['label' => 'État'])
            ->add('urgent', null, ['label' => 'Urgence'])
            ->add('important', null, ['label' => 'Importance'])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Task::class,
        ]);
    }
}
